from django.http import HttpResponse

try:
    from django.utils.deprecation import MiddlewareMixin
    MiddlewareClass = MiddlewareMixin
except ImportError:
    MiddlewareClass = object


class CatchExceptionMiddleware(MiddlewareClass):
    def process_exception(self, request, exception):
        return HttpResponse(status=500)


class HandleErrorMiddlewareSuccess(MiddlewareClass):
    """ Converts an HttpError (that may be returned from an exception handler)
        generated by a view or previous middleware and returns a 200
        HttpResponse.
    """
    def process_response(self, request, response):
        if response.status_code == 500:
            return HttpResponse(status=200)

        return response


class HandleErrorMiddlewareClientError(MiddlewareClass):
    """ Converts an HttpError (that may be returned from an exception handler)
        generated by a view or previous middleware and returns a 404
        HttpResponse.
    """
    def process_response(self, request, response):
        if response.status_code == 500:
            return HttpResponse(status=404)

        return response
